/* Object Rexx (message operator is the tilde: ~), works with Java 1.1 too */
-- using rgf's sort utility package for Object Rexx, which runs on all
-- platforms (including e.g. OS/2)

system=.bsf4rexx~Class.class~forName("string", "java.lang.System")  -- get the class object

properties=system~getProperties     -- get the System properties
   -- this is another possibility to employ the BSF4Rexx utility class via the BSF-interface
enum=.bsf~wrapEnumeration( properties~propertyNames )    -- get an enumeration of the property names
key.=0
say copies("=", 70)
do i=1 to 9999 while enum~hasMoreElements       -- loop over enumeration
   key.i=enum~nextElement           -- get next element
end
key.0=i-1                             -- save # of stem array elements
say "key.0="key.0

arr=sort(key.)             -- now sort the stem, store sorted indices of stem in the array
do i=1 to arr~items
   say "key:" pp(left(arr[i], 30)) "value:" pp(properties~getProperty("String", arr[i]))
end


::requires "BSF.cls"       -- get the Object Rexx support for bsf4rexx
::requires "sort_util" -- get the sort utilities (works under OS/2 as well!)
                       -- <http://wi.wu-wien.ac.at/rgf/rexx/orx08> or one of the other "orx"-dirs

::routine pp   -- "cheap man's pretty print"
  return "[" || arg(1) || "]"

